/********************************** (C) COPYRIGHT *******************************
 * File Name          : main.c
 * Author             : WCH
 * Version            : V1.0.0
 * Date               : 2021/06/06
 * Description        : Main program body.
*********************************************************************************
* Copyright (c) 2021 Nanjing Qinheng Microelectronics Co., Ltd.
* Attention: This software (modified or not) and binary are used for 
* microcontroller manufactured by Nanjing Qinheng Microelectronics.
*******************************************************************************/

/*
 *@Note
 USART Print debugging routine:
 USART1_Tx(PA9).
 This example demonstrates using USART1(PA9) as a print debug port output.

*/

#include "debug.h"

/* Global typedef */

/* Global define */

/* Global Variable */

/*
 ڲ
 UART1  TX-->PA9    DMA1_Channel4       RX-->PA10   DMA1_Channel5
 UART2  TX-->PA2    DMA1_Channel7       RX-->PA3    DMA1_Channel6
 UART3  TX-->PB10   DMA1_Channel2       RX-->PB11   DMA1_Channel3
 UART4  TX-->PB0    DMA1_Channel1       RX-->PB1    DMA1_Channel8
*/

#include "debug.h"

void TIM2_IRQHandler(void)  __attribute__((interrupt("WCH-Interrupt-fast")));

#define USART_MAX_LEN 256

#define USART_GPIO_SPEED GPIO_Speed_2MHz

//Ҫõȫֱ
uint8_t UART[4][USART_MAX_LEN]={0};     //DMA
uint16_t FrameTSet[4] = {0};            //ʱʱ
uint16_t FrameTDif[4] = {0};            //ʱ
uint16_t RxCount[4]   = {0};            //
uint16_t sys1ms    = 0;                 //ʱ1msʱۼ

//RS485IOʼ
void Rs485Ctl_init(void){
    GPIO_InitTypeDef GPIO_InitStructure = {0};
    GPIO_StructInit(&GPIO_InitStructure);                   //ʼṹ
    RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOB,ENABLE);
    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_15;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;
    GPIO_InitStructure.GPIO_Speed = USART_GPIO_SPEED;
    GPIO_Init(GPIOB, &GPIO_InitStructure);
    GPIO_WriteBit(GPIOB, GPIO_Pin_15, Bit_RESET);
}

//ʱʼ
void TIM2_Init( void ){
    TIM_TimeBaseInitTypeDef  TIM_TimeBaseStructure={0};

    RCC_APB1PeriphClockCmd(RCC_APB1Periph_TIM2, ENABLE);

    TIM_TimeBaseStructure.TIM_Period = SystemCoreClock / 1000000 - 1;   //1MHzƵֵ
    TIM_TimeBaseStructure.TIM_Prescaler = 1 * 1000 - 1;                 //1msʱֵ
    TIM_TimeBaseStructure.TIM_ClockDivision = 0;
    TIM_TimeBaseStructure.TIM_CounterMode = TIM_CounterMode_Up;
    TIM_TimeBaseInit(TIM2, &TIM_TimeBaseStructure);
    TIM_ITConfig(TIM2, TIM_IT_Update ,ENABLE);

    TIM_Cmd(TIM2, ENABLE);
    TIM_ClearITPendingBit(TIM2, TIM_IT_Update );
    NVIC_EnableIRQ(TIM2_IRQn);
}

//ʱж
void TIM2_IRQHandler(void){
    TIM_ClearITPendingBit(TIM2, TIM_IT_Update  );
    sys1ms++;
    if(FrameTSet[0] & 0x7FFF) FrameTSet[0]++;
    if(FrameTSet[1] & 0x7FFF) FrameTSet[1]++;
    if(FrameTSet[2] & 0x7FFF) FrameTSet[2]++;
    if(FrameTSet[3] & 0x7FFF) FrameTSet[3]++;
}

//-------------------------------------------------------------------------------------------------------------------------------
//XʼжϡDMA
//1ΪԲ
uint32_t USARTx_Init(USART_TypeDef *USARTx, uint32_t baud){
    uint16_t            GPIO_Pin_Tx,        GPIO_Pin_Rx;
    GPIO_TypeDef        *GPIO_Tx,           *GPIO_Rx;
    DMA_Channel_TypeDef *DMA_Tx,            *DMA_Rx;
    uint8_t             *USARTx_TxBuf,      *USARTx_RxBuf;
    uint32_t            RCC_AHBPeriph;
    uint16_t            tmpTDiff = 4;
    if(baud < 2400){
        tmpTDiff = 20;
    }else if(baud < 4800){
        tmpTDiff = 10;
    }else{
        tmpTDiff = 5;
    }

    if(USARTx == USART1){//UART1  TX-->PA9        DMA1_Channel4           RX-->PA10       DMA1_Channel5
        RCC_APB2PeriphClockCmd(RCC_APB2Periph_USART1 | RCC_APB2Periph_GPIOA, ENABLE);
        GPIO_Pin_Tx   = GPIO_Pin_9;
        GPIO_Pin_Rx   = GPIO_Pin_10;
        GPIO_Tx       = GPIOA;
        GPIO_Rx       = GPIOA;
        DMA_Tx        = DMA1_Channel4;
        DMA_Rx        = DMA1_Channel5;
        RCC_AHBPeriph = RCC_AHBPeriph_DMA1;
        USARTx_TxBuf  = &UART[0][0];
        USARTx_RxBuf  = &UART[0][0];
        FrameTSet[0]  = 0;
        FrameTDif[0] =  tmpTDiff;

    }else if(USARTx == USART2){//UART2  TX-->PA2        DMA1_Channel7           RX-->PA3        DMA1_Channel6
        RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOA,ENABLE);
        RCC_APB1PeriphClockCmd(RCC_APB1Periph_USART2,ENABLE);
        GPIO_Pin_Tx   = GPIO_Pin_2;
        GPIO_Pin_Rx   = GPIO_Pin_3;
        GPIO_Tx       = GPIOA;
        GPIO_Rx       = GPIOA;
        DMA_Tx        = DMA1_Channel7;
        DMA_Rx        = DMA1_Channel6;
        RCC_AHBPeriph = RCC_AHBPeriph_DMA1;
        USARTx_TxBuf  = &UART[1][0];
        USARTx_RxBuf  = &UART[1][0];
        FrameTSet[1]  = 0;
        FrameTDif[1] =  tmpTDiff;

    }else if(USARTx == USART3){//UART3  TX-->PB10       DMA1_Channel2           RX-->PB11       DMA1_Channel3
        RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOB,ENABLE);
        RCC_APB1PeriphClockCmd(RCC_APB1Periph_USART3,ENABLE);
        GPIO_Pin_Tx   = GPIO_Pin_10;
        GPIO_Pin_Rx   = GPIO_Pin_11;
        GPIO_Tx       = GPIOB;
        GPIO_Rx       = GPIOB;
        DMA_Tx        = DMA1_Channel2;
        DMA_Rx        = DMA1_Channel3;
        RCC_AHBPeriph = RCC_AHBPeriph_DMA1;
        USARTx_TxBuf  = &UART[2][0];
        USARTx_RxBuf  = &UART[2][0];
        FrameTSet[2]  = 0;
        FrameTDif[2] =  tmpTDiff;

    }else if(USARTx == UART4){//UART4  TX-->PB0    DMA1_Channel1       RX-->PB1    DMA1_Channel8
        RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOC,ENABLE);
        RCC_APB1PeriphClockCmd(RCC_APB1Periph_UART4,ENABLE);
        GPIO_Pin_Tx   = GPIO_Pin_0;
        GPIO_Pin_Rx   = GPIO_Pin_1;
        GPIO_Tx       = GPIOB;
        GPIO_Rx       = GPIOB;
        DMA_Tx        = DMA1_Channel1;
        DMA_Rx        = DMA1_Channel8;
        RCC_AHBPeriph = RCC_AHBPeriph_DMA1;
        USARTx_TxBuf  = &UART[3][0];
        USARTx_RxBuf  = &UART[3][0];
        FrameTSet[3]  = 0;
        FrameTDif[3] =  tmpTDiff;

    }else{
        return 0;
    }

    //GPOI UARTʱ
    //RCC_APB2PeriphClockCmd(RCC_APB2Periph_Tx,ENABLE);   //GPOI TXʱ
    //RCC_APB2PeriphClockCmd(RCC_APB2Periph_Rx,ENABLE);   //GPOI RXʱ
    //RCC_APB1PeriphClockCmd(RCC_APB1Periph,ENABLE);      //UARTʱ

    //GPIO˿  USARTx˿
    GPIO_InitTypeDef GPIO_InitStructure;
    GPIO_StructInit(&GPIO_InitStructure);                   //ʼṹ
    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_Tx;              // XTxPin?
    GPIO_InitStructure.GPIO_Speed = USART_GPIO_SPEED;       // IOٶ 50MHz Ӿٶ
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP;         // 
    GPIO_Init(GPIO_Tx, &GPIO_InitStructure);                // õ GPIOTx
    GPIO_StructInit(&GPIO_InitStructure);                   //ʼṹ
    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_Rx;              // XRxPin?
    GPIO_InitStructure.GPIO_Speed = USART_GPIO_SPEED;       // IOٶ 50MHz Ӿٶ
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN_FLOATING;   // 
    GPIO_Init(GPIO_Rx, &GPIO_InitStructure);                // õGPIORx

    //USARTx ʼ
    USART_DeInit(USARTx);                                                               //ʼX
    USART_InitTypeDef USART_InitStructure;
    USART_StructInit(&USART_InitStructure);                                             //ʼṹ
    USART_InitStructure.USART_BaudRate = baud;                                          // 
    USART_InitStructure.USART_WordLength = USART_WordLength_8b;                         // 8λ
    USART_InitStructure.USART_StopBits = USART_StopBits_1;                              // 1λֹͣ
    USART_InitStructure.USART_Parity = USART_Parity_No;                                 // У
    USART_InitStructure.USART_HardwareFlowControl = USART_HardwareFlowControl_None;     // Ӳ
    USART_InitStructure.USART_Mode = USART_Mode_Tx | USART_Mode_Rx;                     //  
    USART_Init(USARTx, &USART_InitStructure);                                           // õX

    RCC_AHBPeriphClockCmd(RCC_AHBPeriph, ENABLE);                           //ʹܿDMAʱ
    /* DMA1_ChannelTx,USARTx */
    DMA_InitTypeDef DMA_InitStructure;
    DMA_DeInit(DMA_Tx);                                                     //ʼDMA_ChannelTx
    DMA_StructInit(&DMA_InitStructure);                                     //ʼṹ
    DMA_InitStructure.DMA_PeripheralBaseAddr = (uint32_t)&USARTx->DATAR;    //DMAַ
    DMA_InitStructure.DMA_MemoryBaseAddr     = (uint32_t)USARTx_TxBuf;      //DMA 洢0ַ
    DMA_InitStructure.DMA_DIR                = DMA_DIR_PeripheralDST;       //洢ģʽ
    DMA_InitStructure.DMA_BufferSize         = USART_MAX_LEN;               //ݴ
    DMA_InitStructure.DMA_PeripheralInc      = DMA_PeripheralInc_Disable;   //ģʽ
    DMA_InitStructure.DMA_MemoryInc          = DMA_MemoryInc_Enable;        //洢ģʽ
    DMA_InitStructure.DMA_PeripheralDataSize = DMA_PeripheralDataSize_Byte; //ݳ:8λ
    DMA_InitStructure.DMA_MemoryDataSize     = DMA_MemoryDataSize_Byte;     //洢ݳ:8λ
    DMA_InitStructure.DMA_Mode               = DMA_Mode_Normal;             //ʹͨģʽ
    DMA_InitStructure.DMA_Priority           = DMA_Priority_Medium;         //еȼ
    DMA_InitStructure.DMA_M2M                = DMA_M2M_Disable;             //ֹڴ浽ڴĴ
    DMA_Init(DMA_Tx, &DMA_InitStructure);                                   //õDMA_ChannelTx

    /* DMA1_ChannelRx,X*/
    DMA_DeInit(DMA_Rx);                                                     // ʼDMA_ChannelRx
    DMA_StructInit(&DMA_InitStructure);                                     // ʼṹ
    DMA_InitStructure.DMA_PeripheralBaseAddr = (uint32_t)&USARTx->DATAR;    // DMAַ
    DMA_InitStructure.DMA_MemoryBaseAddr     = (uint32_t)USARTx_RxBuf;      // DMA 洢0ַ
    DMA_InitStructure.DMA_DIR                = DMA_DIR_PeripheralSRC;       // 赽洢ģʽ
    DMA_InitStructure.DMA_BufferSize         = USART_MAX_LEN;               // ݴ
    DMA_InitStructure.DMA_PeripheralInc      = DMA_PeripheralInc_Disable;   // ģʽ
    DMA_InitStructure.DMA_MemoryInc          = DMA_MemoryInc_Enable;        // 洢ģʽ
    DMA_InitStructure.DMA_PeripheralDataSize = DMA_PeripheralDataSize_Byte; // ݳ:8λ
    DMA_InitStructure.DMA_MemoryDataSize     = DMA_MemoryDataSize_Byte;     // 洢ݳ:8λ
    DMA_InitStructure.DMA_Mode               = DMA_Mode_Normal;             // ʹͨģʽ
    DMA_InitStructure.DMA_Priority           = DMA_Priority_VeryHigh;       // ߵȼ
    DMA_InitStructure.DMA_M2M                = DMA_M2M_Disable;             // ֹڴ浽ڴĴ
    DMA_Init(DMA_Rx, &DMA_InitStructure);                                   // õDMA_ChannelRx

    DMA_Cmd(DMA_Tx, DISABLE);                           //ȹرDMA_ChannelTx
    DMA_Cmd(DMA_Rx, DISABLE);                           //ʹDMA_ChannelRxͨʼ

    USART_DMACmd(USARTx, USART_DMAReq_Rx, DISABLE);     //DMA
    USART_DMACmd(USARTx, USART_DMAReq_Tx, DISABLE);     //DMA

    USART_Cmd(USARTx, DISABLE);                         //򿪴X ʼɻ
    return 1;
}


//modbusվ ȡվ
void USART2_master(void){
    static uint16_t USART2_master_task = 0;
    USART_TypeDef *USARTx = USART2;
    uint16_t Index = 1, TxLen = 0, RxLen = 0;
    uint8_t *buf = UART[Index];

    switch (USART2_master_task) {
        case 0: //Ӳʼ
            USARTx_Init(USARTx, 2400);
            Rs485Ctl_init();
            TIM2_Init();
            USART2_master_task = 1;
            printf("Device Init: %d     \r\n", sys1ms);
            break;

        case 1: //ͨ״̬ʼ
            GPIO_WriteBit(GPIOB, GPIO_Pin_15, Bit_RESET);
            DMA_ClearFlag(DMA1_FLAG_TC7);                   //շͱǩ
            DMA_ClearFlag(DMA1_FLAG_TC6);                   //սձǩ
            DMA_Cmd(DMA1_Channel7, DISABLE);                //رDMA_ChannelTx
            DMA_Cmd(DMA1_Channel6, DISABLE);                //رDMA_ChannelRx
            USART_DMACmd(USARTx, USART_DMAReq_Rx, DISABLE); //رմDMA
            USART_DMACmd(USARTx, USART_DMAReq_Tx, DISABLE); //رմDMA
            USART_Cmd(USARTx, DISABLE);                     //رմX
            FrameTSet[Index] = 1;
            USART2_master_task = 2;
            printf("Master Init: %d     \r\n", sys1ms);
            break;

        case 2: //ȴ3.5Tַ
            if(FrameTSet[Index] > FrameTDif[Index]){
                buf[0] = 0x01; buf[1] = 0x03; buf[2] = 0x00; buf[3] = 0x00; buf[4] = 0x00; buf[5] = 0x0A; buf[6] = 0xC5; buf[7] = 0xCD;
                TxLen = 8;
                GPIO_WriteBit(GPIOB, GPIO_Pin_15, Bit_SET);
                USART_Cmd(USARTx, ENABLE);                      //򿪴X
                DMA_SetCurrDataCounter(DMA1_Channel7, TxLen);   //ݷͳ
                USART_DMACmd(USARTx, USART_DMAReq_Tx, ENABLE);  //DMA
                DMA_ClearFlag(DMA1_FLAG_TC7);
                DMA_Cmd(DMA1_Channel7,ENABLE);                  //DMA_Txʼ
                FrameTSet[Index] = 1;
                USART2_master_task = 3;
                printf("Master Send: %d     \r\n", sys1ms);
            }
            break;

        case 3://ȴDMAͽת
            if((DMA_GetFlagStatus(DMA1_FLAG_TC7) != RESET) || (FrameTSet[Index] > 1500)){    //-DMAɻ1.5볬ʱ
                printf("Master SeOk: %d     \r\n", sys1ms);
                DMA_ClearFlag(DMA1_FLAG_TC7);                       // DMA1_IT_TC7ɱ־
                DMA_Cmd(DMA1_Channel7, DISABLE);                    // رDMA_Txٷ
                DMA_ClearFlag(DMA1_FLAG_TC6);                       // DMA_Rxɱ־λ
                USART_DMACmd(USARTx, USART_DMAReq_Tx, DISABLE);     // رմDMA
                if (UART[Index][0] == 0) {                          // ǹ㲥򲻽50ms·ط
                    FrameTSet[Index] = 1;
                    RxCount[Index] = 0;
                    USART2_master_task = 5;
                }else{
                    GPIO_WriteBit(GPIOB, GPIO_Pin_15, Bit_RESET);
                    USART_DMACmd(USARTx, USART_DMAReq_Rx, ENABLE);          // DMA
                    DMA_SetCurrDataCounter(DMA1_Channel6,USART_MAX_LEN);    // ¸ֵֵڵܽյ֡Ŀ
                    DMA_Cmd(DMA1_Channel6, ENABLE);                         // ´DMA_Rxʼ
                    FrameTSet[Index] = 1;
                    RxCount[Index] = 0;
                    USART2_master_task = 4;
                    printf("Master Recv: %d     \r\n", sys1ms);
                }
            }
            break;

        case 4://ȴɼ
            RxLen = USART_MAX_LEN - DMA_GetCurrDataCounter(DMA1_Channel6);  // ȡյݳ λΪֽ
            if(RxCount[Index] != RxLen) {                                   //б仯¼֡
                RxCount[Index] = RxLen;
                FrameTSet[Index] = 1;
            }
            if(RxLen != 0) {
                if (FrameTSet[Index] > FrameTDif[Index]){                   //֡3.5T֡
                    FrameTSet[Index] = 0;
                    USART2_master_task = 1;
                    DMA_Cmd(DMA1_Channel6, DISABLE);                        // رDMA_Rxٽ
                    DMA_ClearFlag(DMA1_FLAG_TC6);                           // DMA_Rxɱ־λ
                    USART_DMACmd(UART4, USART_DMAReq_Rx, DISABLE);          //رմDMA
                    printf("Master ReOk: %d     \r\n", sys1ms);
                }
            }else{
                if(FrameTSet[Index] > 330){                                 //涨ʱûнյκݳʱ
                    USART2_master_task = 1;
                    printf("Master ReEr: %d     \r\n", sys1ms);
                }
            }
            break;

        case 5:
            if(FrameTSet[Index] > 50){                                  //㲥50ms
                printf("Master B/C : %d     \r\n", sys1ms);
                USART2_master_task = 1;
            }
            break;

        default:
            USART2_master_task = 0;
            printf("Task    err: %d     \r\n", sys1ms);
            break;
    }
}

/*********************************************************************
 * @fn      main
 *
 * @brief   Main program.
 *
 * @return  none
 */
int main(void){
    NVIC_PriorityGroupConfig(NVIC_PriorityGroup_2);
    Delay_Init();
    USART_Printf_Init(115200);
    printf("SystemClk:%d\r\n", SystemCoreClock);

    printf("This is printf example\r\n");

    while(1){
        USART2_master();
    }
}
